"use strict";const{Ci,Cu}=require("chrome");Cu.import("resource://gre/modules/XPCOMUtils.jsm");const protocol=require("devtools/server/protocol");const{method,Arg}=protocol;const events=require("sdk/event/core");const Heritage=require("sdk/core/heritage");const{setTimeout,clearTimeout}=require("sdk/timers");const EventEmitter=require("devtools/shared/event-emitter");var ReflowActor=exports.ReflowActor=protocol.ActorClass({typeName:"reflow",events:{"reflows":{type:"reflows",reflows:Arg(0,"array:json")}},initialize:function(conn,tabActor){protocol.Actor.prototype.initialize.call(this,conn);this.tabActor=tabActor;this._onReflow=this._onReflow.bind(this);this.observer=getLayoutChangesObserver(tabActor);this._isStarted=false;},disconnect:function(){this.destroy();},destroy:function(){this.stop();releaseLayoutChangesObserver(this.tabActor);this.observer=null;this.tabActor=null;protocol.Actor.prototype.destroy.call(this);},start:method(function(){if(!this._isStarted){this.observer.on("reflows",this._onReflow);this._isStarted=true;}},{oneway:true}),stop:method(function(){if(this._isStarted){this.observer.off("reflows",this._onReflow);this._isStarted=false;}},{oneway:true}),_onReflow:function(event,reflows){if(this._isStarted){events.emit(this,"reflows",reflows);}}});exports.ReflowFront=protocol.FrontClass(ReflowActor,{initialize:function(client,{reflowActor}){protocol.Front.prototype.initialize.call(this,client,{actor:reflowActor});this.manage(this);},destroy:function(){protocol.Front.prototype.destroy.call(this);},});function Observable(tabActor,callback){this.tabActor=tabActor;this.callback=callback;this._onWindowReady=this._onWindowReady.bind(this);this._onWindowDestroyed=this._onWindowDestroyed.bind(this);events.on(this.tabActor,"window-ready",this._onWindowReady);events.on(this.tabActor,"window-destroyed",this._onWindowDestroyed);}
Observable.prototype={isObserving:false,destroy:function(){if(this.isDestroyed){return;}
this.isDestroyed=true;this.stop();events.off(this.tabActor,"window-ready",this._onWindowReady);events.off(this.tabActor,"window-destroyed",this._onWindowDestroyed);this.callback=null;this.tabActor=null;},start:function(){if(this.isObserving){return;}
this.isObserving=true;this._startListeners(this.tabActor.windows);},stop:function(){if(!this.isObserving){return;}
this.isObserving=false;if(this.tabActor.attached&&this.tabActor.docShell){ this._stopListeners(this.tabActor.windows);}},_onWindowReady:function({window}){if(this.isObserving){this._startListeners([window]);}},_onWindowDestroyed:function({window}){if(this.isObserving){this._stopListeners([window]);}},_startListeners:function(windows){},_stopListeners:function(windows){},notifyCallback:function(...args){this.isObserving&&this.callback&&this.callback.apply(null,args);}};var gIgnoreLayoutChanges=false;exports.setIgnoreLayoutChanges=function(ignore,syncReflowNode){if(syncReflowNode){let forceSyncReflow=syncReflowNode.offsetWidth;}
gIgnoreLayoutChanges=ignore;};function LayoutChangesObserver(tabActor){this.tabActor=tabActor;this._startEventLoop=this._startEventLoop.bind(this);this._onReflow=this._onReflow.bind(this);this._onResize=this._onResize.bind(this);
 this.reflowObserver=new ReflowObserver(this.tabActor,this._onReflow);this.resizeObserver=new WindowResizeObserver(this.tabActor,this._onResize);EventEmitter.decorate(this);}
exports.LayoutChangesObserver=LayoutChangesObserver;LayoutChangesObserver.prototype={EVENT_BATCHING_DELAY:300,destroy:function(){this.isObserving=false;this.reflowObserver.destroy();this.reflows=null;this.resizeObserver.destroy();this.hasResized=false;this.tabActor=null;},start:function(){if(this.isObserving){return;}
this.isObserving=true;this.reflows=[];this.hasResized=false;this._startEventLoop();this.reflowObserver.start();this.resizeObserver.start();},stop:function(){if(!this.isObserving){return;}
this.isObserving=false;this._stopEventLoop();this.reflows=[];this.hasResized=false;this.reflowObserver.stop();this.resizeObserver.stop();},_startEventLoop:function(){
if(!this.tabActor||!this.tabActor.attached){return;} 
if(this.reflows&&this.reflows.length){this.emit("reflows",this.reflows);this.reflows=[];} 
if(this.hasResized){this.emit("resize");this.hasResized=false;}
this.eventLoopTimer=this._setTimeout(this._startEventLoop,this.EVENT_BATCHING_DELAY);},_stopEventLoop:function(){this._clearTimeout(this.eventLoopTimer);}, _setTimeout:function(cb,ms){return setTimeout(cb,ms);},_clearTimeout:function(t){return clearTimeout(t);},_onReflow:function(start,end,isInterruptible){if(gIgnoreLayoutChanges){return;}

this.reflows.push({start:start,end:end,isInterruptible:isInterruptible});},_onResize:function(){if(gIgnoreLayoutChanges){return;}
this.hasResized=true;}};var observedWindows=new Map();function getLayoutChangesObserver(tabActor){let observerData=observedWindows.get(tabActor);if(observerData){observerData.refCounting++;return observerData.observer;}
let obs=new LayoutChangesObserver(tabActor);observedWindows.set(tabActor,{observer:obs,
refCounting:1});obs.start();return obs;}
exports.getLayoutChangesObserver=getLayoutChangesObserver;function releaseLayoutChangesObserver(tabActor){let observerData=observedWindows.get(tabActor);if(!observerData){return;}
observerData.refCounting--;if(!observerData.refCounting){observerData.observer.destroy();observedWindows.delete(tabActor);}}
exports.releaseLayoutChangesObserver=releaseLayoutChangesObserver;function ReflowObserver(tabActor,callback){Observable.call(this,tabActor,callback);}
ReflowObserver.prototype=Heritage.extend(Observable.prototype,{QueryInterface:XPCOMUtils.generateQI([Ci.nsIReflowObserver,Ci.nsISupportsWeakReference]),_startListeners:function(windows){for(let window of windows){let docshell=window.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation).QueryInterface(Ci.nsIDocShell);docshell.addWeakReflowObserver(this);}},_stopListeners:function(windows){for(let window of windows){try{let docshell=window.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation).QueryInterface(Ci.nsIDocShell);docshell.removeWeakReflowObserver(this);}catch(e){
}}},reflow:function(start,end){this.notifyCallback(start,end,false);},reflowInterruptible:function(start,end){this.notifyCallback(start,end,true);}});function WindowResizeObserver(tabActor,callback){Observable.call(this,tabActor,callback);this.onResize=this.onResize.bind(this);}
WindowResizeObserver.prototype=Heritage.extend(Observable.prototype,{_startListeners:function(){this.listenerTarget.addEventListener("resize",this.onResize);},_stopListeners:function(){this.listenerTarget.removeEventListener("resize",this.onResize);},onResize:function(){this.notifyCallback();},get listenerTarget(){if(this.tabActor.isRootActor){return this.tabActor.window;}
return this.tabActor.window.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation).QueryInterface(Ci.nsIDocShell).chromeEventHandler;}});